<template>
  <div v-if="!popularGames.IsHidden" class="pb-[40px]">
    <div class="w-full max-w-full px-4 py-0 mx-auto my-0">
      <div class="section__header">
        <h2 class="section__title">{{ popularGames.Text === '' ? $t("popular_games") : popularGames.Text }}</h2>
        <nuxt-link to="/games/TopGames__n__gt" class="read-more__button">{{
          $t("see_all")
        }}</nuxt-link>
      </div>
      <div class="games__list">
        <div v-for="game in popularGameDatas" :key="game.GameId">
          <div class="games-item" @click="handleClickGame(game)">
            <IconFavorite
              :gameData="game"
              :checkIsFavourite="checkIsFavourite"
              :redirectToLogin="redirectToLogin"
              :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite" :-for-mobile="true"/>
            <div class="games-item__img">
              <img v-lazy="game.GameIconUrl" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div v-if="!newGames.IsHidden" class="pb-[40px]">
    <div class="w-full max-w-full px-4 py-0 mx-auto my-0">
      <div class="section__header">
        <h2 class="section__title">{{ newGames.Text === '' ? $t("new_games") : newGames.Text }}</h2>
        <nuxt-link to="/games/NewGames__n__gt" class="read-more__button">{{
          $t("see_all")
        }}</nuxt-link>
      </div>
      <div class="games__list">
        <div v-for="game in newGameDatas" :key="game.GameId">
          <div class="games-item" @click="handleClickGame(game)">
            <IconFavorite
              :gameData="game"
              :checkIsFavourite="checkIsFavourite"
              :redirectToLogin="redirectToLogin"
              :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite" :-for-mobile="true"/>
            <div class="games-item__img">
              <img v-lazy="game.GameIconUrl" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <game-select-overlay :drawer="drawer" :game="game" />
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { onBeforeRouteLeave } from "vue-router";
import GameSelectOverlay from "./game-select-overlay.client.vue";
import commonHelper from "@/utils/commonHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: {
    GameSelectOverlay,
  },
  props: {
    popularGames: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
    newGames: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
  },
  setup() {
    const popularGameDatas = computed(() =>
      gameStore.state.games
        .filter((game) => game.IsHotGame === true)
        .slice(0, 22)
    );
    const newGameDatas = computed(() =>
      gameStore.state.games
        .filter((game) => game.IsNewGame === true)
        .slice(0, 22)
    );
    const { getAssetImage } = commonHelper;
    const { game, drawer, handleClickGame } = useGameEntryOverlay();
    onBeforeRouteLeave(() => {
      drawer.value = false;
    });
    const sboIcon = `url(${getAssetImage(
      "assets/theme/black_modern_1/images/sbo_icon.png"
    )})`;
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    return {
      popularGameDatas,
      sboIcon,
      newGameDatas,
      game,
      drawer,
      handleClickGame,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    };
  },
});
</script>

<style>
.section__header {
  align-items: center;
  width: 100%;
  justify-content: space-between;
  display: flex;
  position: relative;
  margin-bottom: 24px;
  flex-wrap: wrap;
}
.section__title {
  @apply text-2xl pr-0 flex items-center w-auto mb-0 uppercase;
  transition: color 0.4s;
  color: var(--title-font-color);
}
.read-more__button {
  display: flex;
  justify-content: center;
  align-items: center;
  min-width: 102px;
  width: fit-content;
  padding: 0 20px;
  height: 40px;
  font-weight: 600;
  font-size: 14px;
  line-height: 20px;
  color: #707585;
  text-transform: uppercase;
  border-radius: 6px;
  background-color: var(--button-bg);
  box-shadow: var(--box-shadow);
  flex-shrink: 0;
}
.games__list {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  grid-template-rows: auto;
  grid-gap: 8px;
  margin: auto;
}
.games-item {
  width: 100%;
  max-width: unset;
  margin: unset;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  background: rgba(209, 217, 230, 0.9);
  position: relative;
  -ms-flex-negative: 0;
  flex-shrink: 0;
  border-radius: 8px;
  background-image: v-bind("sboIcon");
  background-repeat: no-repeat;
  background-position: center;
  background-size: 50%;
}
.games-item__img {
  height: 100%;
  padding-top: 67%;
  position: relative;
  overflow: hidden;
  border-radius: 8px;
  box-shadow: var(--box-shadow);
}
.games-item__img img {
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  -o-object-fit: cover;
  object-fit: cover;
  border-radius: 8px;
}
</style>
